Index: uspace/lib/compress/inflate.h
===================================================================
--- uspace/lib/compress/inflate.h	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
+++ uspace/lib/compress/inflate.h	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -0,0 +1,36 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef LIBCOMPRESS_INFLATE_H_
+#define LIBCOMPRESS_INFLATE_H_
+
+#include <sys/types.h>
+
+extern int inflate(void *, size_t, void *, size_t);
+
+#endif
Index: uspace/lib/draw/Makefile
===================================================================
--- uspace/lib/draw/Makefile	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/lib/draw/Makefile	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -31,8 +31,10 @@
 SLIBRARY = libdraw.so.0.0
 LSONAME = libdraw.so0
-EXTRA_CFLAGS += -I$(LIBSOFTREND_PREFIX)
+EXTRA_CFLAGS += -I$(LIBSOFTREND_PREFIX) -I$(LIBCOMPRESS_PREFIX)
 
 SOURCES = \
 	codec/tga.c \
+	codec/tga.gz.c \
+	codec/webp.c \
 	cursor/embedded.c \
 	font/embedded.c \
Index: uspace/lib/draw/codec/tga.c
===================================================================
--- uspace/lib/draw/codec/tga.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/lib/draw/codec/tga.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -110,4 +110,5 @@
  * @return True on succesful decoding.
  * @return False on failure.
+ *
  */
 static bool decode_tga_header(void *data, size_t size, tga_t *tga)
@@ -174,4 +175,5 @@
  * @return Newly allocated surface with the decoded content.
  * @return NULL on error or unsupported format.
+ *
  */
 surface_t *decode_tga(void *data, size_t size, surface_flags_t flags)
@@ -264,4 +266,5 @@
  * @return True on succesful encoding.
  * @return False on failure.
+ *
  */
 bool encode_tga(surface_t *surface, void **pdata, size_t *psize)
Index: uspace/lib/draw/codec/tga.gz.c
===================================================================
--- uspace/lib/draw/codec/tga.gz.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
+++ uspace/lib/draw/codec/tga.gz.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2014 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <errno.h>
+#include <gzip.h>
+#include <malloc.h>
+#include "tga.gz.h"
+#include "tga.h"
+
+/** Decode gzipped Truevision TGA format
+ *
+ * Decode gzipped Truevision TGA format and create a surface
+ * from it. The supported variants of TGA are limited those
+ * supported by decode_tga().
+ *
+ * @param[in] data  Memory representation of gzipped TGA.
+ * @param[in] size  Size of the representation (in bytes).
+ * @param[in] flags Surface creation flags.
+ *
+ * @return Newly allocated surface with the decoded content.
+ * @return NULL on error or unsupported format.
+ *
+ */
+surface_t *decode_tga_gz(void *data, size_t size, surface_flags_t flags)
+{
+	void *data_expanded;
+	size_t size_expanded;
+	
+	int ret = gzip_expand(data, size, &data_expanded, &size_expanded);
+	if (ret != EOK)
+		return NULL;
+	
+	surface_t *surface = decode_tga(data_expanded, size_expanded, flags);
+	
+	free(data_expanded);
+	return surface;
+}
+
+/** Encode gzipped Truevision TGA format
+ *
+ * Encode gzipped Truevision TGA format into an array.
+ *
+ * @param[in]  surface Surface to be encoded into gzipped TGA.
+ * @param[out] pdata   Pointer to the resulting array.
+ * @param[out] psize   Pointer to the size of the resulting array.
+ *
+ * @return True on succesful encoding.
+ * @return False on failure.
+ *
+ */
+bool encode_tga_gz(surface_t *surface, void **pdata, size_t *psize)
+{
+	// TODO
+	return false;
+}
+
+/** @}
+ */
Index: uspace/lib/draw/codec/tga.gz.h
===================================================================
--- uspace/lib/draw/codec/tga.gz.h	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
+++ uspace/lib/draw/codec/tga.gz.h	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2014 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_CODEC_TGA_GZ_H_
+#define DRAW_CODEC_TGA_GZ_H_
+
+#include <sys/types.h>
+#include "../surface.h"
+
+extern surface_t *decode_tga_gz(void *, size_t, surface_flags_t);
+extern bool encode_tga_gz(surface_t *, void **, size_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/codec/webp.c
===================================================================
--- uspace/lib/draw/codec/webp.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
+++ uspace/lib/draw/codec/webp.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -0,0 +1,262 @@
+/*
+ * Copyright (c) 2014 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <stdlib.h>
+#include <byteorder.h>
+#include <align.h>
+#include <stdbool.h>
+#include <fourcc.h>
+#include <pixconv.h>
+#include "webp.h"
+
+/** Check for input buffer overrun condition */
+#define CHECK_OVERRUN(state, retval) \
+	do { \
+		if ((state).overrun) \
+			return (retval); \
+	} while (false)
+
+#define SIGNATURE_WEBP_LOSSLESS  UINT8_C(0x2f)
+
+enum {
+	FOURCC_RIFF          = FOURCC('R', 'I', 'F', 'F'),
+	FOURCC_WEBP          = FOURCC('W', 'E', 'B', 'P'),
+	FOURCC_WEBP_LOSSLESS = FOURCC('V', 'P', '8', 'L')
+};
+
+typedef enum {
+	TRANSFORM_PREDICTOR      = 0,
+	TRANSFORM_COLOR          = 1,
+	TRANSFORM_SUBTRACT       = 2,
+	TRANSFORM_COLOR_INDEXING = 3
+} webp_transform_t;
+
+typedef struct {
+	fourcc_t fourcc;
+	uint32_t payload_size;
+} __attribute__((packed)) riff_header_t;
+
+typedef struct {
+	fourcc_t fourcc;
+	fourcc_t encoding;
+	uint32_t stream_size;
+	uint8_t signature;
+} __attribute__((packed)) webp_header_t;
+
+typedef struct {
+	uint32_t stream_size;
+	uint16_t width;
+	uint16_t height;
+	bool alpha_used;
+	uint8_t version;
+	
+	uint8_t *src;     /**< Input buffer */
+	size_t srclen;    /**< Input buffer size */
+	size_t srccnt;    /**< Position in the input buffer */
+	
+	uint32_t bitbuf;  /**< Bit buffer */
+	size_t bitlen;    /**< Number of bits in the bit buffer */
+	
+	bool overrun;     /**< Overrun condition */
+} webp_t;
+
+/** Get bits from the bit buffer
+ *
+ * @param state WebP state.
+ * @param cnt   Number of bits to return (at most 32).
+ *
+ * @return Returned bits.
+ *
+ */
+static inline uint32_t get_bits(webp_t *state, size_t cnt)
+{
+	/* Bit accumulator for at least 36 bits */
+	uint64_t val = state->bitbuf;
+	
+	while (state->bitlen < cnt) {
+		if (state->srccnt == state->srclen) {
+			state->overrun = true;
+			return 0;
+		}
+		
+		/* Load 8 more bits */
+		val |= ((uint64_t) state->src[state->srccnt]) << state->bitlen;
+		state->srccnt++;
+		state->bitlen += 8;
+	}
+	
+	/* Update bits in the buffer */
+	state->bitbuf = (uint32_t) (val >> cnt);
+	state->bitlen -= cnt;
+	
+	return ((uint32_t) (val & ((1 << cnt) - 1)));
+}
+
+/** Decode WebP header
+ *
+ * @param[in]  data Memory representation of WebP.
+ * @param[in]  size Size of the representation (in bytes).
+ * @param[out] webp Decoded WebP.
+ *
+ * @return True on succesful decoding.
+ * @return False on failure.
+ *
+ */
+static bool decode_webp_header(void *data, size_t size, webp_t *webp)
+{
+	/* Headers sanity check */
+	if ((size < sizeof(riff_header_t)) ||
+	    (size - sizeof(riff_header_t) < sizeof(webp_header_t)))
+		return false;
+	
+	riff_header_t *riff_header = (riff_header_t *) data;
+	if (riff_header->fourcc != FOURCC_RIFF)
+		return false;
+	
+	/* Check payload size */
+	size_t payload_size = uint32_t_le2host(riff_header->payload_size);
+	if (payload_size + sizeof(riff_header_t) > size)
+		return false;
+	
+	data += sizeof(riff_header_t);
+	webp_header_t *webp_header = (webp_header_t *) data;
+	if (webp_header->fourcc != FOURCC_WEBP)
+		return false;
+	
+	/* Only lossless encoding supported so far */
+	if (webp_header->encoding != FOURCC_WEBP_LOSSLESS)
+		return false;
+	
+	webp->stream_size = uint32_t_le2host(webp_header->stream_size);
+	if (webp->stream_size + sizeof(riff_header_t) +
+	    sizeof(webp_header_t) > size)
+		return false;
+	
+	if (webp_header->signature != SIGNATURE_WEBP_LOSSLESS)
+		return false;
+	
+	data += sizeof(webp_header_t);
+	
+	/* Setup decoding state */
+	webp->src = (uint8_t *) data;
+	webp->srclen = webp->stream_size - 1;
+	webp->srccnt = 0;
+	webp->bitbuf = 0;
+	webp->bitlen = 0;
+	webp->overrun = false;
+	
+	/* Decode the rest of the metadata */
+	webp->width = get_bits(webp, 14) + 1;
+	CHECK_OVERRUN(*webp, false);
+	
+	webp->height = get_bits(webp, 14) + 1;
+	CHECK_OVERRUN(*webp, false);
+	
+	webp->alpha_used = get_bits(webp, 1);
+	CHECK_OVERRUN(*webp, false);
+	
+	webp->version = get_bits(webp, 3);
+	CHECK_OVERRUN(*webp, false);
+	
+	if (webp->version != 0)
+		return false;
+	
+	return true;
+}
+
+/** Decode WebP format
+ *
+ * Decode WebP format and create a surface from it. The supported
+ * variants of WebP are currently limited to losslessly compressed
+ * ARGB images.
+ *
+ * @param[in] data  Memory representation of WebP.
+ * @param[in] size  Size of the representation (in bytes).
+ * @param[in] flags Surface creation flags.
+ *
+ * @return Newly allocated surface with the decoded content.
+ * @return NULL on error or unsupported format.
+ *
+ */
+surface_t *decode_webp(void *data, size_t size, surface_flags_t flags)
+{
+	webp_t webp;
+	if (!decode_webp_header(data, size, &webp))
+		return NULL;
+	
+	bool transform_present = false;
+	
+	do {
+		transform_present = get_bits(&webp, 1);
+		CHECK_OVERRUN(webp, NULL);
+		
+		if (transform_present) {
+			webp_transform_t transform = get_bits(&webp, 2);
+			CHECK_OVERRUN(webp, NULL);
+			
+			if (transform == TRANSFORM_PREDICTOR) {
+				// FIXME TODO
+			} else
+				return NULL;
+			
+			// FIXME: decode other transforms
+		}
+	} while (transform_present);
+	
+	// FIXME: decode image data
+	
+	return NULL;
+}
+
+/** Encode WebP format
+ *
+ * Encode WebP format into an array.
+ *
+ * @param[in]  surface Surface to be encoded into WebP.
+ * @param[out] pdata   Pointer to the resulting array.
+ * @param[out] psize   Pointer to the size of the resulting array.
+ *
+ * @return True on succesful encoding.
+ * @return False on failure.
+ *
+ */
+bool encode_webp(surface_t *surface, void **pdata, size_t *psize)
+{
+	// TODO
+	return false;
+}
+
+/** @}
+ */
Index: uspace/lib/draw/codec/webp.h
===================================================================
--- uspace/lib/draw/codec/webp.h	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
+++ uspace/lib/draw/codec/webp.h	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2014 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_CODEC_WEBP_H_
+#define DRAW_CODEC_WEBP_H_
+
+#include <sys/types.h>
+#include "../surface.h"
+
+extern surface_t *decode_webp(void *, size_t, surface_flags_t);
+extern bool encode_webp(surface_t *, void **, size_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/trackmod/Makefile
===================================================================
--- uspace/lib/trackmod/Makefile	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/lib/trackmod/Makefile	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -32,5 +32,6 @@
 SOURCES = \
 	protracker.c \
-	trackmod.c
+	trackmod.c \
+	xm.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/trackmod/protracker.c
===================================================================
--- uspace/lib/trackmod/protracker.c	(revision ef3da5ad625620e40458132c67c6c8d18ecf31fe)
+++ uspace/lib/trackmod/protracker.c	(revision b4121689a97413ef8da0250ed768bb2a55f82865)
@@ -113,4 +113,140 @@
 }
 
+
+/** Decode pattern cell.
+ *
+ * @param pattern Pattern
+ * @param row     Row number
+ * @param channel Channel number
+ * @param cell    Place to store decoded cell
+ */
+static void protracker_decode_cell(uint32_t cdata, trackmod_cell_t *cell)
+{
+	uint32_t code;
+
+	code = uint32_t_be2host(cdata);
+	cell->period = (code >> (4 * 4)) & 0xfff;
+	cell->instr = (((code >> (7 * 4)) & 0xf) << 4) |
+	    ((code >> (3 * 4)) & 0xf);
+	cell->effect = code & 0xfff;
+}
+
+/** Load Protracker patterns.
+ *
+ * @param f      File to read from
+ * @param module Module being loaded to
+ * @return       EOK on success, ENOMEM if out of memory, EIO on I/O error.
+ */
+static int protracker_load_patterns(FILE *f, trackmod_module_t *module)
+{
+	size_t cells;
+	size_t i, j;
+	int rc;
+	size_t nread;
+	uint32_t *buf = NULL;
+
+	cells = module->channels * protracker_pattern_rows;
+	buf = calloc(sizeof(uint32_t), cells);
+
+	if (buf == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	for (i = 0; i < module->patterns; i++) {
+		module->pattern[i].rows = protracker_pattern_rows;
+		module->pattern[i].channels = module->channels;
+		module->pattern[i].data = calloc(sizeof(trackmod_cell_t), cells);
+		if (module->pattern[i].data == NULL) {
+			rc = ENOMEM;
+			goto error;
+		}
+
+		nread = fread(buf, sizeof(uint32_t), cells, f);
+		if (nread != cells) {
+			printf("Error reading pattern.\n");
+			rc = EIO;
+			goto error;
+		}
+
+		/* Decode cells */
+		for (j = 0; j < cells; j++) {
+			protracker_decode_cell(buf[j],
+			    &module->pattern[i].data[j]);
+		}
+	}
+
+	free(buf);
+	return EOK;
+error:
+	free(buf);
+	return rc;
+}
+
+/** Load protracker samples.
+ *
+ * @param f      File being read from
+ * @param sample Sample header
+ * @param module Module being loaded to
+ * @return       EOk on success, ENOMEM if out of memory, EIO on I/O error.
+ */
+static int protracker_load_samples(FILE *f, protracker_smp_t *smp,
+    trackmod_module_t *module)
+{
+	int rc;
+	size_t i;
+	uint8_t ftval;
+	size_t nread;
+	trackmod_sample_t *sample;
+
+	for (i = 0; i < module->instrs; i++) {
+		module->instr[i].samples = 1;
+		module->instr[i].sample = calloc(1, sizeof(trackmod_sample_t));
+		if (module->instr[i].sample == NULL) {
+			printf("Error allocating sample.\n");
+			rc = ENOMEM;
+			goto error;
+		}
+
+		sample = &module->instr[i].sample[0];
+		sample->length =
+		    uint16_t_be2host(smp[i].length) * 2;
+		sample->bytes_smp = 1;
+		sample->data = calloc(1, sample->length);
+		if (sample->data == NULL) {
+			printf("Error allocating sample.\n");
+			rc = ENOMEM;
+			goto error;
+		}
+
+		nread = fread(sample->data, 1, sample->length, f);
+		if (nread != sample->length) {
+			printf("Error reading sample.\n");
+			rc = EIO;
+			goto error;
+		}
+
+		sample->def_vol = smp[i].def_vol;
+
+		sample->loop_start =
+		    uint16_t_be2host(smp[i].loop_start) * 2;
+		sample->loop_len =
+		    uint16_t_be2host(smp[i].loop_len) * 2;
+		if (sample->loop_len <= 2)
+			sample->loop_type = tl_no_loop;
+		else
+			sample->loop_type = tl_forward_loop;
+
+		/* Finetune is a 4-bit signed value. */
+		ftval = smp[i].finetune & 0x0f;
+		sample->finetune =
+			(ftval & 0x8) ? (ftval & 0x7) - 8 : ftval;
+	}
+
+	return EOK;
+error:
+	return rc;
+}
+
 /** Load protracker module.
  *
@@ -128,10 +264,9 @@
 	protracker_order_list_t *order_list;
 	protracker_smp_t *sample;
-	size_t nread;
 	size_t samples;
 	size_t channels;
 	size_t patterns;
-	size_t cells;
-	size_t i, j;
+	size_t i;
+	size_t nread;
 	int rc;
 
@@ -192,7 +327,7 @@
 	module->channels = channels;
 
-	module->samples = samples;
-	module->sample = calloc(sizeof(trackmod_sample_t), samples);
-	if (module->sample == NULL) {
+	module->instrs = samples;
+	module->instr = calloc(sizeof(trackmod_instr_t), samples);
+	if (module->instr == NULL) {
 		printf("Out of memory.\n");
 		rc = ENOMEM;
@@ -221,57 +356,23 @@
 	}
 
+	/* The 'mark' byte may or may not contain a valid restart position */
+	if (order_list->mark < order_list->order_list_len) {
+		module->restart_pos = order_list->mark;
+	}
+
 	/* Load patterns */
-
-	cells = channels * protracker_pattern_rows;
-
-	for (i = 0; i < patterns; i++) {
-		module->pattern[i].rows = protracker_pattern_rows;
-		module->pattern[i].channels = channels;
-		module->pattern[i].data = calloc(sizeof(uint32_t), cells);
-
-		nread = fread(module->pattern[i].data,
-		    sizeof(uint32_t), cells, f);
-		if (nread != cells) {
-			printf("Error reading pattern.\n");
-			rc = EIO;
-			goto error;
-		}
-
-		/* Convert byte order */
-		for (j = 0; j < cells; j++) {
-			module->pattern[i].data[j] = uint32_t_be2host(
-			    module->pattern[i].data[j]);
-		}
-	}
+	rc = protracker_load_patterns(f, module);
+	if (rc != EOK)
+		goto error;
 
 	/* Load samples */
-	for (i = 0; i < samples; i++) {
-		module->sample[i].length =
-		    uint16_t_be2host(sample[i].length) * 2;
-		module->sample[i].data = calloc(1, module->sample[i].length);
-		if (module->sample[i].data == NULL) {
-			printf("Error allocating sample.\n");
-			rc = ENOMEM;
-			goto error;
-		}
-
-		nread = fread(module->sample[i].data, 1, module->sample[i].length,
-			f);
-		if (nread != module->sample[i].length) {
-			printf("Error reading sample.\n");
-			rc = EIO;
-			goto error;
-		}
-
-		module->sample[i].def_vol = sample[i].def_vol;
-		module->sample[i].loop_start =
-		    uint16_t_be2host(sample[i].loop_start) * 2;
-		module->sample[i].loop_len =
-		    uint16_t_be2host(sample[i].loop_len) * 2;
-		if (module->sample[i].loop_len <= 2)
-			module->sample[i].loop_len = 0;
-	}
+	rc = protracker_load_samples(f, sample, module);
+	if (rc != EOK)
+		goto error;
 
 	(void) fclose(f);
+
+	module->def_bpm = protracker_def_bpm;
+	module->def_tpr = protracker_def_tpr;
 
 	*rmodule = module;
